import { InjectionToken as AngularInjectionToken, Injector } from '@angular/core';
import { Router } from '@angular/router';
import { InjectionToken } from '@awesome-nodes/injection-factory';
import { LogTypes } from '@yukawa/chain-base-angular-client';
import * as i0 from "@angular/core";
export declare const SPLASHSCREEN_ANIMATED_TOKEN: AngularInjectionToken<boolean>;
export declare const SPLASHSCREEN_LOG_LEVELS_TOKEN: InjectionToken<LogTypes[]>;
export declare class YukawaSplashScreenService {
    private readonly _document;
    private readonly _injector;
    private readonly _router;
    /**
     * Constructor
     */
    constructor(_document: Document, _injector: Injector, _router: Router);
    static get logsAvailable(): boolean;
    private get hideClassName();
    /**
     * Show the splash screen
     */
    show(): void;
    /**
     * Hide the splash screen
     */
    hide(force?: boolean): void;
    private closSplashScreen;
    static ɵfac: i0.ɵɵFactoryDeclaration<YukawaSplashScreenService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<YukawaSplashScreenService>;
}
